#include <iostream>

using namespace std;

struct node {
    int val;
    struct node* next;
};

void print_list(struct node* head) {
    while (head != NULL) {
        cout << head->val << " ";
        head = head->next;
    }
    cout << endl;
}

void add_front(struct node*& head, int v) {
    struct node* new_node = new struct node;
    new_node->val = v;
    new_node->next = head;
    head = new_node;
}

struct node* add_front_ptr(struct node* head, int v) {
    struct node* new_node = new struct node;
    new_node->val = v;
    new_node->next = head;
    return new_node;
}

void add_front_ptr2(struct node** head, int v) {
    struct node* new_node = new struct node;
    new_node->val = v;
    new_node->next = *head;
    *head = new_node;
}

int get_element(struct node* head, int i) {
    int cnt = 0;

    while (cnt < i && head != NULL) {
        head = head->next;
        cnt++;
    }

    if (head == NULL) {
        cout << "Indeks je van granica liste!" << endl;
        return -1;
    }
    else {
        return head->val;
    }
}

int list_length(struct node* head) {
    int cnt = 0;
    while (head != NULL) {
        head = head->next;
        cnt++;
    }
    return cnt;
}

void add_rear(struct node*& head, int v) {
    struct node* new_node = new struct node;
    new_node->val = v;
    new_node->next = NULL;

    if (head == NULL) {
        head = new_node;
        return;
    }

    struct node* curr_node = head;

    while (curr_node->next != NULL) {
        curr_node = curr_node->next;
    }

    curr_node->next = new_node;
}

void del_first(struct node*& head, int v) {
    struct node* curr_node = head;
    struct node* prev_node = NULL;

    while (curr_node != NULL && curr_node->val != v) {
        prev_node = curr_node;
        curr_node = curr_node->next;
    }

    if (curr_node == NULL) {
        return;
    }

    if (prev_node == NULL) {
        head = head->next;
        delete curr_node;
    }
    else {
        prev_node->next = curr_node->next;
        delete curr_node;
    }
}

void del_all(struct node*& head, int v) {
    struct node* curr_node = head;
    struct node* prev_node = NULL;

    while (curr_node != NULL) {
        if (curr_node->val != v) {
            prev_node = curr_node;
            curr_node = curr_node->next;
        }
        else {
            if (prev_node == NULL) {
                head = head->next;
                delete curr_node;
                curr_node = head;
            }
            else {
                prev_node->next = curr_node->next;
                delete curr_node;
                curr_node = prev_node->next;
            }
        }
    }
}

int main()
{
    struct node n1 = {10, NULL};
    cout << n1.val << " " << n1.next << endl;
    cout << sizeof(n1) << endl;
    cout << &n1 << endl;
    cout << &(n1.val) << endl;
    cout << &(n1.next) << endl;

    struct node* n2 = new struct node;
    (*n2).val = 20;
    n2->next = NULL;

    n1.next = n2;

    cout << &n1 << " " << n2 << endl;

    struct node* head = &n1;
    print_list(head);

    add_front(head, 30);
    head = add_front_ptr(head, 40);
    add_front_ptr2(&head, 50);
    print_list(head);

    cout << get_element(head, 3) << endl;
    cout << list_length(head) << endl;

    add_rear(head, 5);
    print_list(head);
    cout << list_length(head) << endl;

    del_first(head, 30);
    print_list(head);
    cout << list_length(head) << endl;

    // greska !!
    // del_first(head, 10);

    add_front(head, 40);
    add_rear(head, 40);
    print_list(head);

    del_all(head, 40);
    print_list(head);

    return 0;
}
